/*
 * AtomObserver.hpp
 *
 *  Created on: Nov 30, 2011
 *      Author: heber
 */

#ifndef ATOMOBSERVER_HPP_
#define ATOMOBSERVER_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/Singleton.hpp"

#include "EntityObserver.hpp"

class atom;

/** The AtomObserver is a central instance to all changes occuring within atoms.
 *
 * It implements the templated EntityObserver class for atoms.
 *
 * \sa MoleculeObserver
 */
class AtomObserver : public Singleton< AtomObserver >, public EntityObserver<atom>
{
  //!> grant Singleton access to cstor and dstor.
  friend class Singleton< AtomObserver >;

  //!> list of all observed channels
  static const Observable::channels_t AtomChannels;

  // private constructor and destructor due to singleton
  AtomObserver();
};


#endif /* ATOMOBSERVER_HPP_ */
